#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "writeconf.h"


void
on_window1_destroy_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
/*	printf("%s","Window1 destroy event caught\n");	*/
	writeconf(widget,NULL);
	gtk_main_quit();
}


void
on_rombrowse_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *romsel=gtk_file_selection_new("Select ROM");

//connect destroy event
	gtk_signal_connect(GTK_OBJECT(romsel),
		"destroy",
		(GtkSignalFunc)(gtk_widget_destroy),
		(gpointer)romsel);

//connect cancel button
	gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(romsel)->cancel_button),
		"clicked", 
		(GtkSignalFunc)(gtk_widget_destroy),
		(gpointer)romsel);

//connect ok button to romsel_ok_clicked
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(romsel)->ok_button),
		"clicked",
		(GtkSignalFunc)romsel_ok_clicked,
		romsel);

	gtk_widget_show(romsel);
	return;
}


void
on_snapshotbrowse_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *snapsel=gtk_file_selection_new("Select Snapshot");

//connect destroy event
	gtk_signal_connect(GTK_OBJECT(snapsel),
		"destroy",
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(snapsel));

//connect cancel button
	gtk_signal_connect_object(GTK_OBJECT (GTK_FILE_SELECTION
		(snapsel)->cancel_button),
		"clicked", 
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(snapsel));

//connect ok button to snapsel_ok_clicked
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(snapsel)->ok_button),
		"clicked",
		(GtkSignalFunc)snapsel_ok_clicked,
		snapsel);

	gtk_widget_show(snapsel);
	return;

}


void
on_runsnes9x_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	char newargv[50][BUFSIZ];
	int counter=0,
	i;

	GtkWidget 	*hdma,				//checkboxes
				*loadsnapshot,
				*windoweffects,
				*speedhacks,
				*hirom,
				*lorom,
				*interleaved,
				*interleaved2,
				*swaplayering,
				*forcentsc,
				*forcepal,
				*doublesize,
				*soundon,
				*stereo,
				*usejoystick,
				*oldjoystick,
				*swapjoypads,

//				*rom,				//text entries
//				*snapshot,
				*cycles,
				*buffersize,
				*joy1dev,
				*joy2dev,
				*a,
				*b,
				*x,
				*y,
				*l,
				*r,
				*start,
				*select;

				for(i=0;i<50;i++)
					newargv[i][0]='\0';
				strncpy(newargv[counter++],"snes9x",BUFSIZ);

				hdma=lookup_widget(GTK_WIDGET(button),"hdma");
				loadsnapshot=lookup_widget(GTK_WIDGET(button),"loadsnapshot");
				windoweffects=lookup_widget(GTK_WIDGET(button),"windoweffects");
				speedhacks=lookup_widget(GTK_WIDGET(button),"speedhacks");
				hirom=lookup_widget(GTK_WIDGET(button),"hirom");
				lorom=lookup_widget(GTK_WIDGET(button),"lorom");
				interleaved=lookup_widget(GTK_WIDGET(button),"interleaved");
				interleaved2=lookup_widget(GTK_WIDGET(button),"interleaved2");
				swaplayering=lookup_widget(GTK_WIDGET(button),"swaplayering");
				forcentsc=lookup_widget(GTK_WIDGET(button),"forcentsc");
				forcepal=lookup_widget(GTK_WIDGET(button),"forcepal");
				doublesize=lookup_widget(GTK_WIDGET(button),"doublesize");
				soundon=lookup_widget(GTK_WIDGET(button),"soundon");
				stereo=lookup_widget(GTK_WIDGET(button),"stereo");
				usejoystick=lookup_widget(GTK_WIDGET(button),"usejoystick");
				oldjoystick=lookup_widget(GTK_WIDGET(button),"oldjoystick");
				swapjoypads=lookup_widget(GTK_WIDGET(button),"swapjoypads");

				cycles=lookup_widget(GTK_WIDGET(button),"cycles");
				buffersize=lookup_widget(GTK_WIDGET(button),"buffersize");
				joy1dev=lookup_widget(GTK_WIDGET(button),"joy1dev");
				joy2dev=lookup_widget(GTK_WIDGET(button),"joy2dev");
				a=lookup_widget(GTK_WIDGET(button),"a");
				b=lookup_widget(GTK_WIDGET(button),"b");
				x=lookup_widget(GTK_WIDGET(button),"x");
				y=lookup_widget(GTK_WIDGET(button),"y");
				l=lookup_widget(GTK_WIDGET(button),"l");
				r=lookup_widget(GTK_WIDGET(button),"r");
				start=lookup_widget(GTK_WIDGET(button),"start");
				select=lookup_widget(GTK_WIDGET(button),"select");

				if(!(GTK_TOGGLE_BUTTON(hdma)->active))
					strncpy(newargv[counter++],"-H",BUFSIZ);

				if((GTK_TOGGLE_BUTTON(loadsnapshot)->active)){
					strncpy(newargv[counter],"-l ",BUFSIZ);
					strncat(newargv[counter++],
						gtk_entry_get_text(GTK_ENTRY(snapshot)),
						BUFSIZ-strlen(newargv[counter]-1));
				}//if

				if(!(GTK_TOGGLE_BUTTON(windoweffects)->active))
					strncpy(newargv[counter++],"-nw",BUFSIZ);

				if(!(GTK_TOGGLE_BUTTON(speedhacks)->active))
					strncpy(newargv[counter++],"-N",BUFSIZ);

				if(GTK_TOGGLE_BUTTON(hirom)->active)
					strncpy(newargv[counter++],"-FH",BUFSIZ);
				else if(GTK_TOGGLE_BUTTON(lorom)->active)
					strncpy(newargv[counter++],"-FL",BUFSIZ);

				if(GTK_TOGGLE_BUTTON(interleaved)->active)
					strncpy(newargv[counter++],"-i",BUFSIZ);
				else if(GTK_TOGGLE_BUTTON(interleaved2)->active)
					strncpy(newargv[counter++],"-i2",BUFSIZ);

				if(GTK_TOGGLE_BUTTON(swaplayering)->active)
					strncpy(newargv[counter++],"-L",BUFSIZ);

				if(GTK_TOGGLE_BUTTON(forcentsc)->active)
					strncpy(newargv[counter++],"-ntsc",BUFSIZ);
				else if(GTK_TOGGLE_BUTTON(forcepal)->active)
					strncpy(newargv[counter++],"-pal",BUFSIZ);

				if(GTK_TOGGLE_BUTTON(doublesize)->active)
					strncpy(newargv[counter++],"-y",BUFSIZ);
				if(GTK_TOGGLE_BUTTON(soundon)->active){
					if(GTK_TOGGLE_BUTTON(stereo)->active)
						strncpy(newargv[counter++],"-stereo",BUFSIZ);
					if(strcmp(gtk_entry_get_text(GTK_ENTRY(buffersize)),"") && 
						strcmp(gtk_entry_get_text(GTK_ENTRY(buffersize)),"auto")){
						strncpy(newargv[counter++],"-B",BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(buffersize)),BUFSIZ);
					}//if
				}//if soundon
				else strcpy(newargv[counter++],"-NS");

				if(GTK_TOGGLE_BUTTON(usejoystick)->active){
					if(GTK_TOGGLE_BUTTON(oldjoystick)->active)
						strncpy(newargv[counter++],"-old",BUFSIZ);

					if(GTK_TOGGLE_BUTTON(swapjoypads)->active)
						strncpy(newargv[counter++],"-s",BUFSIZ);

					if((strcmp(gtk_entry_get_text(GTK_ENTRY(joy1dev)),""))){
						strncpy(newargv[counter++],"-joydev1",BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(joy1dev)),BUFSIZ);
						strcpy(newargv[counter++],"-joymap1");
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(a)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(b)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(x)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(y)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(l)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(r)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(start)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(select)),BUFSIZ);
					}//if
					if(strcmp(gtk_entry_get_text(GTK_ENTRY(joy2dev)),"")){
						strcpy(newargv[counter++],"-joydev2");
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(joy2dev)),BUFSIZ);
						strcpy(newargv[counter++],"-joymap2");
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(a)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(b)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(x)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(y)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(l)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(r)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(start)),BUFSIZ);
						strncpy(newargv[counter++],
							gtk_entry_get_text(GTK_ENTRY(select)),BUFSIZ);
					}//if
				}//if
				else strcpy(newargv[counter++],"-nojoy");

				if(strcmp(gtk_entry_get_text(GTK_ENTRY(cycles)),"")){
					strncpy(newargv[counter++],"-cycles",BUFSIZ);
					strncpy(newargv[counter++],
						gtk_entry_get_text(GTK_ENTRY(cycles)),BUFSIZ);
				}//if

				strncpy(newargv[counter++],
					gtk_entry_get_text(GTK_ENTRY(rom)),BUFSIZ);

/*				for(i=0;i<50;i++){
					printf("%s ",newargv[i]);
				}//for
				printf("\n");
*/

				
				execsnes9x(newargv,counter);
				
/*				newargv[counter++]=NULL;
				if(!fork()){
					returncode=execvp("snes9x",newargv);
					if(returncode<0)
						printf("%s\n",strerror(errno));
				}
				else sleep(3);
*/
}//run


void
on_cancel_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	writeconf(GTK_WIDGET(button),NULL);
	gtk_main_quit();
}


void
on_loadrom_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *romsel=gtk_file_selection_new("Load conf file");
	char	goosnesdir[BUFSIZ];

	get_goosnesdir(goosnesdir);
	/*	printf("%s\n",goosnesdir);	*/
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(romsel),goosnesdir);

//connect destroy event
	gtk_signal_connect(GTK_OBJECT(romsel),
		"destroy",
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(romsel));

//connect cancel button
	gtk_signal_connect_object(GTK_OBJECT 
		(GTK_FILE_SELECTION(romsel)->cancel_button),
		"clicked", 
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)romsel);

//connect ok button to romsel_ok_clicked
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(romsel)->ok_button),
		"clicked",
		(GtkSignalFunc)loadrom_ok_clicked,
		button);

	gtk_widget_show(romsel);
	return;
}


void
on_saverom_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *romsel=gtk_file_selection_new("Save conf file");
	char	goosnesdir[BUFSIZ];

	get_goosnesdir(goosnesdir);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(romsel),goosnesdir);

//connect destroy event
	gtk_signal_connect(GTK_OBJECT(romsel),
		"destroy",
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(romsel));

//connect cancel button
	gtk_signal_connect_object(GTK_OBJECT (GTK_FILE_SELECTION
		(romsel)->cancel_button),
		"clicked", 
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(romsel));

//connect ok button to romsel_ok_clicked
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(romsel)->ok_button),
		"clicked",
		(GtkSignalFunc)saverom_ok_clicked,
		button);

	gtk_widget_show(romsel);
	return;
}



int romsel_ok_clicked(GtkWidget *w,
						GtkFileSelection *fs)
{
	gtk_entry_set_text(GTK_ENTRY(rom),
		gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
	gtk_widget_destroy(GTK_WIDGET(fs));
	return 0;
}//romsel_ok_clicked

int loadrom_ok_clicked(GtkWidget *w,
						GtkWidget *p)
{
	int retval=0;
	char	buf[BUFSIZ];
	GtkFileSelection	*fs=GTK_FILE_SELECTION(gtk_widget_get_toplevel(w));
	strncpy(buf,gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)),BUFSIZ);

	gtk_widget_destroy(GTK_WIDGET(fs));
	retval=readconf(p,buf);

	return retval;
}//loadrom_ok_clicked

int saverom_ok_clicked(GtkWidget *w,
						GtkWidget *p)
{
	int retval=0;
	char	buf[BUFSIZ];

	GtkFileSelection	*fs=GTK_FILE_SELECTION(gtk_widget_get_toplevel(w));
	strncpy(buf,gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)),BUFSIZ);

	gtk_widget_destroy(GTK_WIDGET(fs));
	retval=writeconf(p, buf);

	return retval;
}//saverom_ok_clicked

int snes9x_sel_ok_clicked(GtkWidget *w,
						GtkFileSelection *fs)
{
	gtk_entry_set_text(GTK_ENTRY(snes9x_entry),
		gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
	gtk_widget_destroy(GTK_WIDGET(fs));
	return 0;
}//romsel_ok_clicked


int snapsel_ok_clicked(GtkWidget *w,
						GtkFileSelection *fs)
{
	gtk_entry_set_text(GTK_ENTRY(snapshot),
		gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
	gtk_widget_destroy(GTK_WIDGET(fs));
	return 0;
}//snapsel_ok_clicked


int execsnes9x(char newargv[50][BUFSIZ],int newargc){
	char *passme[newargc+1];
	int i,
	returncode=0;

/*	printf("entered execsnes9x\n");	*/

	for(i=0;i<newargc;i++){
		passme[i]=(char*)malloc(BUFSIZ*sizeof(char));
		strncpy(passme[i],newargv[i],BUFSIZ);
		printf("%s ",passme[i]);
	}//for
	printf("\n");
	passme[newargc]=NULL;

	if(!fork()){
//		returncode=execvp("snes9x",passme);
		returncode=execvp(gtk_entry_get_text(GTK_ENTRY(snes9x_entry)),passme);
		if(returncode<0)
			printf("Error: %s\n",strerror(errno));
	}//if child

	else sleep(3);

	for(i=0;i<newargc;i++)
		free(passme[i]);

	return returncode;
}//execsnes9x

void
on_snes9x_browse_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *snes9x_sel=gtk_file_selection_new("Select ROM");

//connect destroy event
	gtk_signal_connect(GTK_OBJECT(snes9x_sel),
		"destroy",
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(snes9x_sel));

//connect cancel button
	gtk_signal_connect_object(GTK_OBJECT (GTK_FILE_SELECTION
		(snes9x_sel)->cancel_button),
		"clicked", 
		(GtkSignalFunc)gtk_widget_destroy,
		(gpointer)(snes9x_sel));

//connect ok button to snes9x_sel_ok_clicked
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(snes9x_sel)->ok_button),
		"clicked",
		(GtkSignalFunc)snes9x_sel_ok_clicked,
		snes9x_sel);

	gtk_widget_show(snes9x_sel);
	return;
}

int	get_goosnesdir(char	*buf){
		char	*home=getenv("HOME");
		int	retval=1;

		if(home){
			strncpy(buf,home,BUFSIZ);
			strncat(buf,"/.goosnes/",BUFSIZ-strlen(buf)-1);
		}//if
		else{	//no HOME variable to check
				retval=0;
		}//else

		return retval;
}//get_goosnesdir
