#include "readconf.h"


int readconf(GtkWidget *button,char *conffile){
		return readxmlconf(button,conffile);
}//readconf

int	readxmlconf(GtkWidget *button,char *buf){
				xmlDocPtr	conffile;
				xmlNodePtr	curr,
							temp;
				int	newbuf=0;


				if(NULL == buf){
					newbuf=1;
					buf=(char*)malloc(BUFSIZ*sizeof(char));
					assert(NULL != buf);
					get_conffilename(buf);
				}//if

				conffile=xmlParseFile(buf);
/*				printf("Parsed %s\n",buf);	*/

/*				printf("Using %s as conf file\n",buf); */

				if(newbuf){
					free(buf);
				}//if

				if(NULL == conffile){	//no config file
						return 0;
				}//if

				curr=xmlDocGetRootElement(conffile);

				if(NULL == curr){	//empty document
						printf("%s","Unable to open conffile - using defaults\n");
						return 0;
				}//if

				temp=curr;
				if(xmlStrcmp(temp->name,(const xmlChar *)"goosnes")){
						printf("%s","Incorrectly formatted file\n");
				/*		printf("%s should be %s\n",temp->name,"goosnes");	*/
						xmlFreeDoc(conffile);
						return 0;
				}//if
				else{
				/*		printf("Found root element %s\n",temp->name);	*/
				}//else

				for(temp=temp->children;NULL != temp;temp=temp->next){
						if(!xmlStrcmp(temp->name,(const xmlChar *)"rom")){
						/*		printf("%s\n","Parsing rom section");	*/
								parserom(button,conffile,temp->xmlChildrenNode);
						}//if
						else if(!xmlStrcmp(temp->name,(const xmlChar *)"screen")){
						/*		printf("%s\n","Parsing screen section");	*/
								parsescreen(button,conffile,temp->xmlChildrenNode);
						}//if
						else if(!xmlStrcmp(temp->name,(const xmlChar *)"sound")){
						/*		printf("%s\n","Parsing sound section");	*/
								parsesound(button,conffile,temp->xmlChildrenNode);
						}//if
						else if(!xmlStrcmp(temp->name,(const xmlChar *)"joystick")){
						/*		printf("%s\n","Parsing joystick section");	*/
								parsejoystick(button,conffile,temp->xmlChildrenNode);
						}//if
						else if(!xmlStrcmp(temp->name,(const xmlChar *)"text")){}
						else{
								printf("%s","Incorrectly formatted file\n");
								printf("%s is not a valid section\n",temp->name); 
								xmlFreeDoc(conffile);
								return 0;
						}//else
				}//for

				xmlFreeDoc(conffile);
				return 1;
}//readxmlconf


int	parserom(GtkWidget *button,xmlDocPtr doc,xmlNodePtr curr){

		GtkWidget 	*rom,
					*snapshot,
					*hdma,
					*loadsnapshot,
					*windoweffects,
					*speedhacks,
					*hirom,
					*lorom,
					*interleaved,
					*interleaved2,
					*swaplayering;

				xmlChar	*temp;


				rom=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"rom"));
				snapshot=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"snapshot"));
				hdma=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"hdma"));
				loadsnapshot=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"loadsnapshot"));
				windoweffects=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"windoweffects"));
				speedhacks=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"speedhacks"));
				hirom=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"hirom"));
				lorom=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"lorom"));
				interleaved=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"interleaved"));
				interleaved2=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"interleaved2"));
				swaplayering=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"swaplayering"));


				for(;NULL != curr;curr=curr->next){
						if(!xmlStrcmp(curr->name,"romfile")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									gtk_entry_set_text(GTK_ENTRY(rom),temp);
									/* printf("%s\n",temp); */
									free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"snapshotfile")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									gtk_entry_set_text(GTK_ENTRY(snapshot),temp);
									free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"hdma")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y")){
											gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(hdma),1);
									}//if
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"loadsnapshot")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y")){
											gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(loadsnapshot),1);
									}//if
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"windoweffects")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(windoweffects),0);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"speedhacks")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(speedhacks),0);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"forcehi")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y")
									 && (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lorom))))
											gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(hirom),1);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"forcelo")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y")
										&& (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(hirom))))
											gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lorom),1);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"interleaved")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(interleaved),1);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"interleaved2")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(interleaved2),1);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"swaplayering")){
								temp=xmlNodeListGetString(doc,curr->children,1);
								if(NULL != temp){
									if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(swaplayering),1);
								free(temp);
								}//if
						}//if
						else if(!xmlStrcmp(curr->name,"text")){
						}//if
						else{
								printf("%s","Incorrectly formatted file\n");
								printf("%s is not a valid rom option\n",curr->name); 
								return 0;
						}//else
				}//for

				return 1;
}//parserom

int	parsescreen(GtkWidget *button,xmlDocPtr doc,xmlNodePtr curr){
		GtkWidget	*forcentsc,
					*forcepal,
					*doublesize,
					*cycles,
					*snes9x;
		xmlChar	*temp;

		cycles=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"cycles"));
		snes9x=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"snes9x_entry"));
		forcentsc=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"forcentsc"));
		forcepal=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"forcepal"));
		doublesize=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"doublesize"));

		for(;NULL != curr;curr=curr->next){
				if(!xmlStrcmp(curr->name,"cycles")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(cycles),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"snes9x")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(snes9x),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"forcentsc")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(forcentsc),1);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"forcepal")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"y") 
									&& !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(forcentsc)))
											gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(forcepal),1);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"doublescreensize")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(doublesize),0);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"text")){
				}//else
				else{
								printf("%s","Incorrectly formatted file\n");
								printf("%s is not a valid screen option\n",curr->name); 
						return 0;
				}//else
		}//for

		return 1;
}//parsescreen

int	parsesound(GtkWidget *button,xmlDocPtr doc,xmlNodePtr curr){
		GtkWidget	*sound,
					*stereo,
					*buffersize;
		xmlChar	*temp;

		sound=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"soundon"));
		stereo=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"stereo"));
		buffersize=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"buffersize"));

		for(;NULL != curr;curr=curr->next){
				if(!xmlStrcmp(curr->name,"usesound")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(sound),0);
						}//if
						else free(temp);
				}//if
				else if(!xmlStrcmp(curr->name,"stereo")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stereo),0);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"buffersize")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(buffersize),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"text")){
				}//if
				else{
								printf("%s","Incorrectly formatted file\n");
								printf("%s is not a valid sound option\n",curr->name); 
						return 0;
				}//else
		}//for

		return 1;
}//parsesound

int	parsejoystick(GtkWidget *button,xmlDocPtr doc,xmlNodePtr curr){
		GtkWidget	*usejoystick,
					*oldjoystick,
					*swapjoypads,
					*joy1dev,
					*joy2dev,
					*a,
					*b,
					*x,
					*y,
					*l,
					*r,
					*start,
					*select;
		xmlChar	*temp;

		usejoystick=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"usejoystick"));
		oldjoystick=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"oldjoystick"));
		swapjoypads=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"swapjoypads"));
		joy1dev=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"joy1dev"));
		joy2dev=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"joy2dev"));
		a=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"a"));
		b=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"b"));
		x=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"x"));
		y=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"y"));
		l=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"l"));
		r=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"r"));
		start=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"start"));
		select=GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"select"));

		for(;NULL != curr;curr=curr->next){
				if(!xmlStrcmp(curr->name,"usejoystick")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"n"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(usejoystick),0);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"oldjoystick")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(oldjoystick),1);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"swapjoypads")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
								if(!xmlStrcmp(temp,"y"))
										gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(swapjoypads),1);
						free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"joy1dev")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(joy1dev),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"joy2dev")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(joy2dev),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"a")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(a),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"b")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(b),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"x")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(x),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"y")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(y),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"l")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(l),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"r")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(r),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"start")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(start),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"select")){
						temp=xmlNodeListGetString(doc,curr->children,1);
						if(NULL != temp){
							gtk_entry_set_text(GTK_ENTRY(select),temp);
							free(temp);
						}//if
				}//if
				else if(!xmlStrcmp(curr->name,"text")){
				}//if
				else{
								printf("%s","Incorrectly formatted file\n");
								printf("%s is not a valid joystick option\n",curr->name); 
						return 0;
				}//else
		}//for

		return 1;
}//parsejoystick
